/*
 * WsDmaPort.h
 *
 * Created: 10.10.2018 18:48:31
 *  Author: Thomas F
 */ 


#ifndef WSDMAPORT_H_
#define WSDMAPORT_H_



#include <stdbool.h>
#include "sam.h"
#include "misc.h"


int WsDmaPortInit(PortGroup* portGroup,		// Port for WS output
				uint8_t usedPinPattern,		// Pin pattern for WS output
				uint8_t portByteOffset,		// Octet number
				uint8_t* dmaBuffer,			// DMA buffer
				uint16_t dmaBufferSize,		// DMA buffer size (LED count is calculate from this value)
				uint8_t* rgbData[],			// Array of eight(one if only one channel is used) pointers to RGB data. 
				_Bool signalInvert);		// WS output invert


#define WS_RGB2DMA_PORT_FAST	// Needs extra 4k flash, approximately 2.5 times faster

int ConvertRgbToDmaOneChannel(void);	// RGB data are taken from wsRgbData[0]

int ConvertRgbToDma8Channels(void);

int WsDmaPortStartTransfer(void);

_Bool IsWsDmaPortTransferActiv(void);



#endif /* WSDMAPORT_H_ */